10 'Program thin film analysis
11 'Author:Henrik Kaker,Dec-1987
12 CLEAR:color 7,0,0
13 KEY OFF:cls
19 T$="Thin Film Analysis Program"
20 LOCATE 5,(80-LEN(T$))/2
21 PRINT T$
22 locate 9,22
23 input"File name (without *.dat) : ",f$
34 'file transformations
36 OPEN"i",#1,f$+".dat"
37 I=0
38 WHILE NOT EOF(1)
39 INPUT #1,A$
40 I=I+1
41 WEND
42 CLOSE #1
43 OPEN"i",#2,f$+".dat"
44 OPEN"o",#3,"data.dat"
45 I=0
46 WHILE NOT EOF(2)
47 INPUT #2,A$
48 IF I>=5 THEN PRINT #3,A$
49 I=I+1
50 WEND
51 CLOSE
52 OPEN"i",#4,"data.dat"
53 N=0
54 WHILE NOT EOF(4)
55 INPUT #4,A$
56 N=N+1
57 WEND
58 CLOSE #4
59 OPEN"i",#5,"data.dat"
60 OPEN"o",#6,"elem.dat"
61 FOR I=1 TO N
62 INPUT #5,A$
63 A$=LEFT$(A$,2)
64 PRINT #6,A$
65 NEXT I
66 CLOSE
67 OPEN"i",#7,"data.dat"
68 OPEN"o",#8,"line.dat"
69 FOR I=1 TO N
70 INPUT #7,A$
71 A$=LEFT$(A$,6)
72 B$=RIGHT$(A$,3)
73 PRINT #8,B$
74 NEXT I
75 CLOSE
76 OPEN"i",#9,"data.dat"
77 OPEN"o",#10,"cps.dat"
78 FOR I=1 TO N
79 INPUT #9,A$
80 A$=RIGHT$(A$,15)
81 PRINT #10,A$
82 NEXT I
83 CLOSE
104 DIM AA(16),L$(16),L(16),Z$(16),Z(16),A5(16),A6(16),OO(16),EC(16),U(16)
105 DIM Q(16),A(16),I(16),K(16),M1(16),M2(16),M3(16),T(16),P(16),CC(16)
106 DIM R(16),S(16),XX(16),C(16),G(16),Y(16),M100(16),M200(16),M300(16)
135 OPEN "I",#2,"spt.DAT"
136 INPUT #2,V1:INPUT #2,V2:INPUT #2,V3:INPUT #2,V4
137 V1=V1*.0001:V2=V2*.0001:V3=V3*.0001
140 OPEN"i",#3,"Cond.dat"
142 INPUT #3,V
144 INPUT #3,N99:N99=.0174533*N99
146 INPUT #3,T:T=.0174533*T
148 INPUT #3,BCF
150 CLOSE
155 V=V*1000
158 IF V=>30000 THEN V=(1+9.875E-07*V)*V
160 OPEN"i",#4,"elem.dat"
162 AA=0
164 WHILE NOT EOF(4)
165 INPUT #4,XYZ
166 AA=AA+1
168 WEND
170 CLOSE
210 LOCATE 13,23
220 INPUT"Elements or oxides (e/o) : ",UU$
282 OPEN"i",#5,"elem.dat"
283 OPEN"i",#6,"line.dat"
284 OPEN"i",#7,"cps.dat"
285 IF UU$="O" OR UU$="o" GOTO 286 ELSE 290
286 CLS:LOCATE 3,18
287 PRINT TAB(18)"Element";TAB(28)"Line";TAB(38)"Int",TAB(48)"Stehiom.ratio"
290 FOR N1=1 TO AA
300 INPUT #5,Z$(N1):Z$(N1)=UCASE$(Z$(N1))
301 IF Z$(N1)="C" THEN Z(N1)=6
302 IF Z$(N1)="N" THEN Z(N1)=7
303 IF Z$(N1)="O" THEN Z(N1)=8
304 IF Z$(N1)="F" THEN Z(N1)=9
305 IF Z$(N1)="NA" THEN Z(N1)=11
306 IF Z$(N1)="MG" THEN Z(N1)=12
307 IF Z$(N1)="AL" THEN Z(N1)=13
308 IF Z$(N1)="SI" THEN Z(N1)=14
309 IF Z$(N1)="S" THEN Z(N1)=16
310 IF Z$(N1)="CL" THEN Z(N1)=17
311 IF Z$(N1)="K" THEN Z(N1)=19
312 IF Z$(N1)="CA" THEN Z(N1)=20
313 IF Z$(N1)="SC" THEN Z(N1)=21
314 IF Z$(N1)="TI" THEN Z(N1)=22
315 IF Z$(N1)="V" THEN Z(N1)=23
316 IF Z$(N1)="CR" THEN Z(N1)=24
317 IF Z$(N1)="MN" THEN Z(N1)=25
318 IF Z$(N1)="FE" THEN Z(N1)=26
319 IF Z$(N1)="CO" THEN Z(N1)=27
320 IF Z$(N1)="NI" THEN Z(N1)=28
321 IF Z$(N1)="CU" THEN Z(N1)=29
322 IF Z$(N1)="ZN" THEN Z(N1)=30
323 IF Z$(N1)="GA" THEN Z(N1)=31
324 IF Z$(N1)="GE" THEN Z(N1)=32
325 IF Z$(N1)="AS" THEN Z(N1)=33
326 IF Z$(N1)="SE" THEN Z(N1)=34
327 IF Z$(N1)="BR" THEN Z(N1)=35
328 IF Z$(N1)="RB" THEN Z(N1)=37
329 IF Z$(N1)="SR" THEN Z(N1)=38
330 IF Z$(N1)="Y" THEN Z(N1)=39
331 IF Z$(N1)="ZR" THEN Z(N1)=40
332 IF Z$(N1)="NB" THEN Z(N1)=41
333 IF Z$(N1)="MO" THEN Z(N1)=42
334 IF Z$(N1)="TC" THEN Z(N1)=43
335 IF Z$(N1)="RU" THEN Z(N1)=44
336 IF Z$(N1)="RH" THEN Z(N1)=45
337 IF Z$(N1)="PD" THEN Z(N1)=46
338 IF Z$(N1)="AG" THEN Z(N1)=47
339 IF Z$(N1)="CD" THEN Z(N1)=48
340 IF Z$(N1)="IN" THEN Z(N1)=49
341 IF Z$(N1)="SN" THEN Z(N1)=50
342 IF Z$(N1)="SB" THEN Z(N1)=51
343 IF Z$(N1)="TE" THEN Z(N1)=52
344 IF Z$(N1)="I" THEN Z(N1)=53
345 IF Z$(N1)="CS" THEN Z(N1)=55
346 IF Z$(N1)="BA" THEN Z(N1)=56
347 IF Z$(N1)="LA" THEN Z(N1)=57
348 IF Z$(N1)="CE" THEN Z(N1)=58
349 IF Z$(N1)="PR" THEN Z(N1)=59
350 IF Z$(N1)="ND" THEN Z(N1)=60
351 IF Z$(N1)="PM" THEN Z(N1)=61
352 IF Z$(N1)="SM" THEN Z(N1)=62
353 IF Z$(N1)="EU" THEN Z(N1)=63
354 IF Z$(N1)="GD" THEN Z(N1)=64
355 IF Z$(N1)="TB" THEN Z(N1)=65
356 IF Z$(N1)="DY" THEN Z(N1)=66
357 IF Z$(N1)="HO" THEN Z(N1)=67
358 IF Z$(N1)="ER" THEN Z(N1)=68
359 IF Z$(N1)="TM" THEN Z(N1)=69
360 IF Z$(N1)="YB" THEN Z(N1)=70
361 IF Z$(N1)="LU" THEN Z(N1)=71
362 IF Z$(N1)="HF" THEN Z(N1)=72
363 IF Z$(N1)="TA" THEN Z(N1)=73
364 IF Z$(N1)="W" THEN Z(N1)=74
365 IF Z$(N1)="RE" THEN Z(N1)=75
366 IF Z$(N1)="OS" THEN Z(N1)=76
367 IF Z$(N1)="IR" THEN Z(N1)=77
368 IF Z$(N1)="PT" THEN Z(N1)=78
369 IF Z$(N1)="AU" THEN Z(N1)=79
370 IF Z$(N1)="HG" THEN Z(N1)=80
371 IF Z$(N1)="TL" THEN Z(N1)=81
372 IF Z$(N1)="PB" THEN Z(N1)=82
373 IF Z$(N1)="BI" THEN Z(N1)=83
374 IF Z$(N1)="U" THEN Z(N1)=92
375 IF Z$(N1)="P" THEN Z(N1)=15
380 INPUT #6,L$(N1):L$(N1)=UCASE$(L$(N1))
400 IF L$(N1)="K  " THEN L(N1)=1
410 IF L$(N1)="L  " THEN L(N1)=2
415 IF L$(N1)="M  " THEN L(N1)=3
440 INPUT #7,A5(N1)
450 IF UU$="O" OR UU$="o" GOTO 451 ELSE 470
451 'data for oxide
453 LOCATE (4+N1),21:PRINT Z$(N1)
454 LOCATE (4+N1),29:PRINT L$(N1)
455 LOCATE (4+N1),34:PRINT USING"######.###";A5(N1)
456 LOCATE (4+N1),53:INPUT"",A6(N1)
470 NEXT N1
480 'calc.parameters in Cliff-Lorimer method
490 FOR N1=1 TO AA
500 'fluorescence yield
510 IF L(N1)=1 THEN OO(N1)= (-.03795+.03426*Z(N1)-1.163E-06*Z(N1)^3)^4/(1+(-.03795+.03426*Z(N1)-1.163E-06*Z(N1)^3)^4)
520 IF L(N1)=2 THEN OO(N1)=(-.11107+.01368*Z(N1)-2.177E-07*Z(N1)^3)^4/(1+(-.11107+.01368*Z(N1)-2.177E-07*Z(N1)^3)^4)
525 IF L(N1)=3 THEN OO(N1)=(-.00036+.00368*Z(N1)+2.01E-07*Z(N1)^3)^4/(1+(-.00036+.00368*Z(N1)+2.01E-07*Z(N1)^3)^4)
530 'ionization cross-section
540 'absortion edge energy
550 IF L(N1)=1 THEN EC(N1)=-.1304-.002633*Z(N1)+.009718*Z(N1)^2+4.144E-05*Z(N1)^3
560 IF L(N1)=2 THEN EC(N1)=-.4506+.01566*Z(N1)+.0007599*Z(N1)^2+1.792E-05*Z(N1)^3
565 IF L(N1)=3 THEN EC(N1)=-8.645001+.3977*Z(N1)-.005963*Z(N1)^2+3.624E-05*Z(N1)^3
570 'overvoltage ratio
575 EC(N1)=EC(N1)*1000
580 U(N1)=V/EC(N1)
590 IF L(N1)=1 THEN B=.35
600 IF L(N1)=2 THEN B=.25
605 IF L(N1)=3 THEN B=.25
610 CC(N1)=4/(1.65+2.35*EXP(1-U(N1)))
620 IF L(N1)=1 THEN ZZ=2
630 IF L(N1)=2 THEN ZZ=8
635 IF L(N1)=3 THEN ZZ=18
640 'ionization cross-section
650 Q(N1)=(6.51E-14*ZZ*B/(EC(N1)^2*U(N1)))*LOG(CC(N1)*U(N1))
660 'atomic weights
670 A(N1)=-1.42+1.97*Z(N1)+.0103*Z(N1)^2-.0000429*Z(N1)^3
680 'line intensity fraction
690 IF L(N1)=1 THEN 692
692 GOSUB 5000
700 IF L(N1)=2 THEN 702
702 GOSUB 5500
710 IF L(N1)=3 THEN I(N1)=.86
760 'energy of charcteristic lines
770 IF L(N1)=1 THEN K(N1)=-.06654-8.608999E-03*Z(N1)+ .00963*Z(N1)^2+7.268E-06*Z(N1)^3+1.131E-07*Z(N1)^4
780 IF L(N1)=2 THEN K(N1)=.04776-.01706*Z(N1)+.001523*Z(N1)^2+4.414E-06*Z(N1)^3-1.739E-08*Z(N1)^4
785 IF L(N1)=3 THEN K(N1)=EXP(6.66542-11.2046*LOG(Z(N1))+3.58209*(LOG(Z(N1)))^2-.303821*(LOG(Z(N1)))^3)
790 'Si(Li) efficiency
800 IF K(N1)=<1.487 THEN M100=.3102*(12.3981/K(N1))^3.001
801 IF K(N1)>1.487 THEN M100=2.4604*.111*(12.3981/K(N1))^3.03
810 IF K(N1)=<1.487 THEN M200=1.759*(12.3981/K(N1))^2.706
811 IF K(N1)>1.487 AND K(N1)<=2.0147 THEN M200=9.130901*1.8389*(12.3981/K(N1))^2.94
812 IF K(N1)>2.0147 THEN M200=19.57*(12.3981/K(N1))^2.7345
820 IF K(N1)=<1.487 THEN M300=41.17*(12.3981/K(N1))^1.906
821 IF K(N1)>1.487 AND K(N1)<=2.2057 THEN M300=19.4943*.7558*(12.3981/K(N1))^2.393
822 IF K(N1)>2.2057 AND K(N1)<=2.2911 THEN M300=19.4943*2.2057*(12.3981/K(N1))^2.2
823 IF K(N1)>2.2911 AND K(N1)<=2.743 THEN M300=19.4943*2.2911*(12.3981/K(N1))^2.4
824 IF K(N1)>2.743 AND K(N1)<=3.1478 THEN M300=19.4943*2.743*(12.3981/K(N1))^2.4471
825 IF K(N1)>3.1478 AND K(N1)<=3.4249 THEN M300=19.4943*3.1478*(12.3981/K(N1))^2.4471
826 IF K(N1)>3.4249 AND K(N1)<=11.9187 THEN M300=19.4943*3.4249*(12.3981/K(N1))^2.575
827 IF K(N1)>11.9187 AND K(N1)<=13.7336 THEN M300=19.4943*11.9187*(12.3981/K(N1))^2.3554
828 IF K(N1)>13.7336 AND K(N1)<=14.3528 THEN M300=19.4943*13.7336*(12.3981/K(N))^2.61439
829 IF K(N1)>14.3528 THEN M300=19.4943*14.3528*(12.3981/K(N1))^2.65
830 T(N1)=EXP(-M100*(V1/COS(T))*1.85-M200*(V3/COS(T))*2.329-M300*(V2/COS(T))*19.3)*(1-EXP(-M200*(V4/COS(T))*2.329))
920 'calc. P-factors
930 P(N1)=Q(N1)*OO(N1)*I(N1)*T(N1)/A(N1)
940 NEXT N1
950 'calc.concentration without absorption and fluorescence effect
955 XX=0
960 FOR N1=1 TO AA
970 R(N1)=A5(N1)/A5(1)
980 S(N1)=P(1)/P(N1)
990 XX(N1)=S(N1)*R(N1)
1000 XX=XX+XX(N1)
1010 NEXT N1
1020 C1=1/XX
1040 FOR N1=1 TO AA
1050 C(N1)=S(N1)*R(N1)*C1
1060 NEXT N1
1070 'atomic percent
1075 FOR N1=1 TO AA
1080 A(N1)=-1.42+1.97*Z(N1)+.0103*Z(N1)^2-.0000429*Z(N1)^3
1090 G(N1)=(C(N1)*100)/A(N1)
1100 NEXT N1
1110 GG=0
1120 FOR N1=1 TO AA
1130 GG=GG+G(N1)
1140 NEXT N1
1150 'weight percent
1160 YY=0
1170 FOR N1=1 TO AA
1175 A(N1)=-1.42+1.97*Z(N1)+.0103*Z(N1)^2-.0000429*Z(N1)^3
1180 Y(N1)=(C(N1)*100)*(A(N1)+A6(N1)*15.9994)/A(N1)
1190 YY=YY+Y(N1)
1200 NEXT N1
1210 'line printer
1220 IF UU$="E" OR UU$="e" GOTO 1230 ELSE 1330
1230 CLS
1240 LOCATE 3,1
1250 PRINT TAB(1)"Element";TAB(12)"Line";TAB(21)"Int";TAB(29)"P(1)/P(N)";TAB(42)"Weight percent";TAB(59)"Atomic percent"
1260 FOR N1=1 TO AA
1270 LOCATE (5+N1),4:PRINT"";Z$(N1);TAB(13)"";L$(N1);
1274 LOCATE (5+N1),15:PRINT USING"######.###";A5(N1)
1280 LOCATE (5+N1),29:PRINT USING"##.###";S(N1)
1290 LOCATE (5+N1),44:PRINT USING"###.###";C(N1)*100
1300 LOCATE (5+N1),61:PRINT USING"###.###";(G(N1)*100)/GG
1310 NEXT N1
1320 GOTO 1420
1330 'weight percent oxide
1340 CLS
1345 LOCATE 3,1
1350 PRINT TAB(1)"Element";TAB(12)"Line";TAB(21)"Int";TAB(29)"P(1)/P(N1)";TAB(42)"Weight percent";TAB(59)"Weight percent oxide"
1360 FOR N1=1 TO AA
1370 LOCATE (5+N1),4:PRINT"";Z$(N1);TAB(13)"";L$(N1);
1374 LOCATE (5+N1),15:PRINT USING"######.###";A5(N1)
1380 LOCATE (5+N1),30:PRINT USING"##.###";S(N1)
1390 LOCATE (5+N1),44:PRINT USING"###.###";C(N1)*100
1400 LOCATE (5+N1),62:PRINT USING"###.###";(Y(N1)*100)/YY
1410 NEXT N1
1420 LOCATE 23,30:INPUT"Hard copy (y/n): ",HHH$
1422 IF HHH$="n" OR HHH$="N" GOTO 4000
1424 IF HHH$="y" OR HHH$="Y" GOTO 1430
1430 CLS:LOCATE 13,28
1480 INPUT"Please type sample name: ",SX$
1490 IF UU$="E" OR UU$="e" GOTO 1600
1500 IF UU$="O" OR UU$="o" GOTO 1900
1600 LPRINT:LPRINT:LPRINT:LPRINT
1610 LPRINT CHR$(27)+"G";
1620 LPRINT TAB(24)"Program Thin Film Analysis"
1630 LPRINT CHR$(27)+"H";
1640 LPRINT:LPRINT
1650 LPRINT TAB(30)"  Date: ";DATE$
1660 LPRINT TAB(30)"  Time: ";TIME$
1670 LPRINT TAB(30)"Sample: ";SX$
1680 LPRINT:LPRINT
1685 V=V/1000
1690 LPRINT TAB(16)"Accelerating voltage: ";
1691 LPRINT USING"###.###";V;
1692 LPRINT" keV"
1700 LPRINT TAB(16)"      Take-off angle: ";INT((57.32484*T*100+.5)/100);" degrees"
1710 LPRINT TAB(16)"  Number of elements: ";AA
1720 LPRINT:LPRINT
1730 LPRINT TAB(1)"Element";TAB(12)"Line";TAB(21)"Int";TAB(29)"P(1)/P(N)";TAB(42)"Weight percent";TAB(59)"Atomic percent"
1740 LPRINT
1750 FOR N1=1 TO AA
1760 LPRINT TAB(4)"";Z$(N1);TAB(13)"";L$(N1);TAB(16)"";
1770 LPRINT USING"######.###";A5(N1);
1780 LPRINT TAB(29);
1785 LPRINT USING"##.###";S(N1);
1790 LPRINT TAB(44);
1795 LPRINT USING"###.###";C(N1)*100;
1800 LPRINT TAB(61);
1805 LPRINT USING"###.###";(G(N1)*100)/GG
1810 NEXT N1
1820 GOTO 4000
1900 LPRINT:LPRINT:LPRINT
1910 LPRINT CHR$(27)+"G";
1920 LPRINT TAB(25)"Program Thin Film Analysis"
1930 LPRINT CHR$(27)+"H";
1940 LPRINT:LPRINT
1950 LPRINT TAB(30)"  Date: ";DATE$
1960 LPRINT TAB(30)"  Time: ";TIME$
1970 LPRINT TAB(30)"Sample: ";SX$
1980 LPRINT:LPRINT
1985 V=V/1000
1990 LPRINT TAB(16)"Accelerating voltage: ";
1991 LPRINT USING"###.###";V;
1994 LPRINT" keV"
2000 LPRINT TAB(16)"      Take-off angle: ";INT((57.32484*T*100+.5)/100);" degrees"
2010 LPRINT TAB(16)"  Number of elements: ";AA
2020 LPRINT:LPRINT
2030 LPRINT TAB(1)"Element";TAB(12)"Line";TAB(21)"Int";TAB(29)"P(1)/P(N)";TAB(42)"Weight percent";TAB(59)"Weight % oxide"
2040 LPRINT
2050 FOR N1=1 TO AA
2060 LPRINT TAB(4)"";Z$(N1);TAB(13)"";L$(N1);TAB(16)"";
2070 LPRINT USING"######.###";A5(N1);
2080 LPRINT TAB(29);
2085 LPRINT USING"##.###";S(N1);
2090 LPRINT TAB(44);
2095 LPRINT USING"###.###";C(N1)*100;
2100 LPRINT TAB(61);
2110 LPRINT USING"###.###";(Y(N1)*100)/YY
2130 NEXT N1
4000 CLS
4040 kill"data.dat"
4050 kill"elem.dat"
4060 kill"line.dat"
4070 kill"cps.dat"
4090 END
5000 'line intensity fraction for K-lines
5010 IF Z(N1)<=19 THEN I(N1)=1.052-.000439*Z(N1)^2
5020 IF Z(N1)>19 AND Z(N1)<=29 THEN I(N1)=.896-.0006575*Z(N1)
5030 IF Z(N1)>29  THEN I(N1)=1.0366-.00682*Z(N1)+4.815E-05*Z(N1)^2
5040 RETURN
5500 'line intensity fraction for L-lines
5510 IF Z(N1)<=44 THEN I(N1)=.944
5520 IF Z(N1)>44 THEN I(N1)=-.4461+.05493*Z(N1)-.0007717*Z(N1)^2+3.525E-06*Z(N1)^3
5530 RETURN
